unit EditorProject1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, TMenus, TVCLControl, TBar, ImgList, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    TBar: TTBar;
    ImListSt: TImageList;
    ImListHighL: TImageList;
    ImListDisA: TImageList;
    RichEdit: TRichEdit;
    OpenDia: TOpenDialog;
    SaveDia: TSaveDialog;
    Memo: TMemo;
    ResFilesMenu: TTResFilesMenu;
    procedure FormCreate(Sender: TObject);
    procedure TBarButtons0ButtClick(Sender: TObject; ButtDown: Boolean);
    Function Savefile(FileName: String): Boolean;
    procedure UpDateButtonState;
    procedure TBarButtons2ButtDownClick(Sender: TObject);
    procedure ResFilesMenuClick(Sender: TObject; Caption: String);
    procedure TBarButtDownClickAbout(Sender: TObject);
    procedure TBarButtUpClickUp(Sender: TObject);
    procedure TBarButMoveDownClick(Sender: TObject);
    procedure TBarButSaveAsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TBarComBo: TComBoBox;
  MovingBut: TButt;
  CurrentFile: String;

const
  TBarButNew = 0;
  TBarButOpen = 2;
  TBarButSave = 4;
  TBarButSaveAs = 5;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
Var I: Integer;
begin
 TBarComBo := TComBoBox(TBar.Buttons.Items[7].Control);
 MovingBut := TBar.Buttons.Items[13];// hold link to button as it moves in items order
 TBarComBo.Style := csDropDownList;
 For I := 0 to 9 do TBarComBo.Items.Add('Line No ' + IntToStr(I));
 TBarComBo.ItemIndex := 5;
 TEdit(TBar.Buttons.Items[9].Control).Text := 'TBar Editor';
 TBar.Buttons[TBarButSave].Enabled := False;
 TBar.Buttons[TBarButSaveAs].Enabled := False;
 RichEdit.Align := alClient;
 Form1.Height := 500;
 Form1.Width := 900;
 Memo.Align := alClient;
 Memo.Visible := False;   
end;

procedure TForm1.TBarButtons0ButtClick(Sender: TObject; ButtDown: Boolean);
begin
 CurrentFile := '';
 RichEdit.Lines.Clear;
end;

Function TForm1.Savefile(FileName: String): Boolean;
Var Save: Word;
begin
  Result := True;
  If (Length(FileName) > 0)
    and (TBar.Buttons[TBarButSave].Enabled) then
   begin
    Save := MessageDlg('Save Current File 1st?', mtCustom, [mbYes, mbNo, mbCancel], 0);
    If Save = mrCancel then Result := False;
    If Save = mrOk then RichEdit.Lines.SaveToFile(FileName);
    ResFilesMenu.AddFileName(CurrentFile, False);
   end;
end;

procedure TForm1.UpDateButtonState;
begin
  If Length(CurrentFile) > 0 then
   begin
    TBar.Buttons[TBarButSave].Enabled := True;
    TBar.Buttons[TBarButSaveAs].Enabled := True;
   end
   else begin
    TBar.Buttons[TBarButSave].Enabled := False;
    TBar.Buttons[TBarButSaveAs].Enabled := False;
        end;
end;

procedure TForm1.TBarButtons2ButtDownClick(Sender: TObject);
begin
 If OpenDia.Execute then
  begin
   ResFilesMenu.SetFileNameVisible(CurrentFile, True);
   CurrentFile := OpenDia.FileName;
   RichEdit.Lines.LoadFromFile(OpenDia.FileName);
   ResFilesMenu.AddFileName(CurrentFile, False);
   UpDateButtonState;
  end;
end;

procedure TForm1.ResFilesMenuClick(Sender: TObject; Caption: String);
begin
  while (Pos(' ', Caption) > 0) and (Pos(' ', Caption) < 4) do
    Caption := Copy(Caption, 2, 255);
  ResFilesMenu.AddFileName(Caption, False);
  CurrentFile := Caption;
  RichEdit.Lines.LoadFromFile(Caption);
end;

procedure TForm1.TBarButtDownClickAbout(Sender: TObject);
begin
 Memo.Visible := true;
end;

procedure TForm1.TBarButtUpClickUp(Sender: TObject);
begin
 Memo.Visible := False;
end;

procedure TForm1.TBarButMoveDownClick(Sender: TObject);
begin
  If MovingBut.Index = 13 then MovingBut.Index := 5
                       else MovingBut.Index := 13;
end;

procedure TForm1.TBarButSaveAsClick(Sender: TObject);
begin
 ResFilesMenu.SetFileNameVisible(CurrentFile, True);
 SaveDia.InitialDir := ResFilesMenu.StartUpDir;
 If SaveDia.Execute then
  begin
    ResFilesMenu.AddFileName(SaveDia.FileName, False);
    RichEdit.Lines.SaveToFile(SaveDia.FileName);
    CurrentFile := SaveDia.FileName;
  end;
end;

end.
